<p>Najjednostavniju vrstu programirljivih modula čine <em>ispisne memorije</em> (engl. 
   <i>Read-Only Memory</i>, ROM). Tehnološki, možemo razmatrati tri vrste ispisnih
   memorija:
</p>
<ul>
<li>one koje se programiraju u tvornici tijekom proizvodnje,</li>
<li>one koje korisnik sam može jednom isprogramirati i potom je sadržaj nepromjenjiv, te</li>
<li>one koje korisnik može više puta (npr. desetak puta) programirati odnosno brisati.</li>
</ul>
<p>O načinima na koji se to tehnološki ostvaruje, govorit ćemo detaljnije na predavanjima.
   Za sada je važno napomenuti da sve tri vrste navedenih memorija (kao i programirljivi
   moduli porodica PLA i PAL) imaju zajedničku strukturu koja se sastoji od jednog
   dekodera i jednog kodera. Ponekad ćemo koristiti i termine <i>jedno dekodersko polje</i>
   te <i>jedno kodersko polje</i>.
</p>
<p>U digitalnim sustavima, pojam "memorija" uobičajeno označava sklopovsku komponentu
   koja omogućava pamćenje niza podataka. Podatci su pri tome smješteni na memorijske
   lokacije, a svaka memorijska lokacija može pamtiti određen broj bitova. Primjerice,
   neka bi memorija mogla imati 3 adresna ulaza i 4 podatkovna izlaza. Ta bi memorija
   omogućavala pamćenje osam (\(2^{\text{broj adresnih bitova}}\)) podatkovnih riječi, gdje je
   svaka duljine 4 bita. Ukupan kapacitet takve memorije bio bi \(8 \cdot 4 = 32\) bita.
   Postavljanjem odgovarajuće kombinacije nula i jedinica na adresne ulaze, korisnik bi
   odredio koju podatkovnu riječ želi dobiti na izlazima (odredio bi memorijsku lokaciju).
   Bitovi pohranjeni na toj memorijskoj lokaciji pojavili bi se na izlazu memorije.
</p>
<p>Kod ROM-a, na ulaze dekodera se dovode <i>adresni bitovi</i> koji određuju željenu
   memorijsku lokaciju čiji je sadržaj potrebno postaviti na podatkovne izlaze memorije.
   Dekoder ima onoliko izlaza koliko postoji memorijskih lokacija. Ako imamo \(n\)-bitovnu
   adresu, koristit ćemo binarni dekoder koji ima \(n\) adresnih ulaza te \(2^n\) izlaza.
   Izlaze dekodera u ovom scenariju nazivamo <i>linijama retka</i>. Zahvaljujući činjenici
   da kod binarnog dekodera samo jedan izlaz može biti postavljen na vrijednost 1, 
   postavljanjem jedinice na jednu od linija retka dekoder selektira memorijsku lokaciju
   čiji sadržaj treba postaviti na podatkovne izlaze memorije.
</p>

<p>Pogledajte interaktivnu simulaciju u nastavku: prikazana je građa ispisne memorije
   \(8 \times 4\) koja ima 8 memorijskih riječi i na svakoj pohranjuje jedan četiri-bitni
   podatak.
</p>

<script>
@#page-include#(canvasActRegUtil.js)
@#page-include#(numbersUtil.js)
@#page-include#(coderDecoder.js)
</script>

<div style="text-align: center; margin-top: 15px; margin-bottom: 15px;">
<canvas id="myCanvas1" width="330" height="280" oncontextmenu="return false;"></canvas><br>
Organizacija ispisne memorije kao kombinacija dekodera i kodera.
</div>

<script>
    new KoderDekoder(3, 4, "myCanvas1", null, [
        [1,1,0,0],
        [1,0,0,1],
        [0,1,1,1],
        [0,0,1,0],
        [1,1,0,0],
        [0,1,0,1],
        [0,1,0,0],
        [0,0,1,0]
      ], true, true, null, null, 0);
</script>

<p>Linije retka su vodoravni segmenti koji su prikazani između dekodera i kodera.
   Crvenom bojom je prikazana ona linija retka koja je u logičkoj jedinici
   (tj. koja je adresirana narinutom kombinacijom adresnih bitova). Vrijednosti adresnih
   bitova možete mijenjati klikom na pločicu koja ih prikazuje - pogledajte kako njihova 
   promjena mijenja odabranu liniju retka.
</p>

<p>Koder koji je na slici prikazan kao desna komponenta na temelju odabrane memorijske
   lokacije na izlazu treba postaviti podatak koji memorija pohranjuje na toj lokaciji.
   U ovoj simulaciji, sadržaj po memorijskim lokacijama u koderu je prikazan raspisan 
   po bitovima, a desno i u heksadekadskom zapisu. Gledano po memorijskim lokacijama,
   ova memorija čuva redom {1100, 1001, 0111, 0010, 1100, 0101, 0100, 0010} odnosno 
   očitamo li sadržaj u heksadekadskom sustavu, {C, 9, 7, 2, C, 5, 4, 2}.
</p>

<p>U nastavku slijedi zadatak koji će Vam pomoći da utvrdite jeste li savladali upravo
   izloženo.</p>

